<?php

/**
 * AbraFlexi - Objekt adresáře.
 *
 * @author     Vítězslav Dvořák <vitex@arachne.cz>
 * @copyright  (C) 2015-2017 Spoje.Net
 */

namespace Test\AbraFlexi;

use AbraFlexi\Adresar;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2016-04-27 at 17:54:36.
 */
class AdresarTest extends RWTest {

    /**
     * @var Adresar
     */
    protected $object;

    /**
     * Prepare Testing Invoice
     * 
     * @param array $initialData
     * 
     * @return \AbraFlexi\FakturaVydana
     */
    public static function makeTestAddress($initialData = []) {
        $testCode = 'TEST_' . time();

        $address->takeData(array_merge([
            'kod' => $testCode,
            'name' => 'TESTer',
            'poznam' => 'AbraFlexi Test Address',
                        ], $initialData));
        if ($address->sync()) {
            $address->addStatusMessage($address->getApiURL() . ' ' . \AbraFlexi\RO::uncode($address->getDataValue('typDokl')) . ' ' . \AbraFlexi\RO::uncode($address->getRecordIdent()) . ' ' . \AbraFlexi\RO::uncode($address->getDataValue('sumCelkem')) . ' ' . \AbraFlexi\RO::uncode($address->getDataValue('mena')),
                    'success');
        } else {
            $address->addStatusMessage(json_encode($address->getData()), 'debug');
        }

        return $address;
    }

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp(): void {
        $this->object = new Adresar();
    }

    /**
     * @covers AbraFlexi\Adresar::getNotificationEmailAddress
     */
    public function testGetNotificationEmailAddress() {
        $this->object->setMyKey('id');
        $found = $this->object->getNotificationEmailAddress();
    }

    /**
     * @covers AbraFlexi\Adresar::getCellPhoneNumber
     */
    public function testGetCellPhoneNumber() {
        $this->object->getCellPhoneNumber();
    }

    /**
     * @covers AbraFlexi\Adresar::getAnyPhoneNumber
     */
    public function testGetAnyPhoneNumber() {
        $this->object->getAnyPhoneNumber();
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown(): void {
        
    }

}
